<%
OPTION EXPLICIT
'--------------------------------------------------------------------------
'This file contains code that can be used for hosting local registration
'   it includes routines both for registering clickers, and looking up registrations
'   
'   To configure you must set the URL for this page 
'
'    Const LocalRegURL = "http://physwebdev.physics.uiuc.edu/PERG/test/Register.asp"
    Const LocalRegURL = "Register.asp"
'   
'------------------------------------------------------------------------------------------------
'   For SQL  database use lines below
'
'          Const MyDataBase = "SQL"             'uncomment this line for SQL registration and be sure nonSQL lines are commented
'          Const SQLTableName = "clickers"      'uncomment this line for SQL registration and be sure nonSQL lines are commented
'
'          In iclicker preferences set the webcode to:  "SQL" & LocalRegURL & "?c="  (e.g. "SQLhttp://physwebdev.physics.uiuc.edu/PERG/Register.asp?c=")
'          To set up the SQL server table with table name "clickers" use the command below.
'            create table clickers (firstname varchar(100), lastname varchar(100),studentId varchar(100), clickerId varchar(100), whenadded datetime not null, unique (firstname, lastname, studentId , clickerId))
'------------------------------------------------------------------------------------------------
'   For ACCESS database use 3 lines below
'
          Const MyDataBase = "Access"             'uncomment this line for Access registration and be sure SQL and Flat file lines are commented.
          Const SQLTableName = "clickers"         'uncomment this line for Access registration and be sure SQL and Flat file lines are commented.
          Const AccessFileName = "clickers.mdb"   'uncomment this life for Access registration and be sure SQL and Flat file lines are commented.
'
'          AccessFilename should be given relative to directory of this code. (Current example has database in same directory as code.)          
'
'          In iclicker preferences set the webcode to:  "SQL" & LocalRegURL & "?c="  (e.g. "SQLhttp://physwebdev.physics.uiuc.edu/PERG/Register.asp?c=")
'--------------------------------------------------------------------------------------------------
'   For Flat File registration use lines below
'
'       Const MyDataBase = "Flat"                       'uncomment this line for nonSQL registration and be sure SQL/Access lines above are commented
'       Const RegFileName = "LocalClickerRegFile.txt"   'uncomment this line for nonSQL registration and be sure SQL/Access lines above are commented
'
'        In iclicker preferences set the webcode to the full URL for the RegFileName       (e.g.  http://physwebdev.physics.uiuc.edu/PERG/test/LocalClickerRegFile.txt )
'
'----------------------------------------------------------------------------


Response.AddHeader "pragma","no-cache"
Response.AddHeader "cache-control","private"
dim ValidEntry
dim Status
dim ClickerID
dim theClickerID, theFirstName, theLastName, theStudentID

'---------------------------------------
' First we determine if this is a lookup 
' or registration
' or form request
'---------------------------------------

clickerid = request.querystring("c")
if (len(clickerid) > 4) then
    if (MyDataBase = "SQL" ) then
        call SQLlookupclickerid(clickerid)
    else 
        call Accesslookupclickerid(clickerid)
    End if
Else

    thefirstname = request.form("First_Name")
    thelastname = request.form("Last_Name")
    thestudentid = request.form("Student_ID")
    theclickerid = request.form("Clicker_ID")

'-------------------------------------------------
'  First check to see if this is first time visit
'  or an attempt to register a clicker
'--------------------------------------------------
    if (len(theclickerid & thelastname & thestudentid & thefirstname) < 2) then
        WriteForm thefirstname, thelastname, thestudentid, theclickerid
    else
'----------------------------------
' Now we clean up the clicker ID
'-----------------------------------
        theclickerid =ucase(theclickerid)
        theclickerid = trim(theclickerid)
        while (len(theclickerid) < 8 and len(theclickerid) > 1)
            theclickerid = "0" & theclickerid
        wend
'-----------------------------------------------------------
'  Assume everything is OK then do some checks on form data
'-----------------------------------------------------------
        ValidEntry = "TRUE"
'-------------------------------------
'   Check Student ID
'--------------------------------------
        if (len(thestudentid) < 3 or len(thestudentid) > 12) then
            response.write "<p><H2>Error! Invalid StudentID </H2>"   
            response.write "Student ID should be between 3 and 12 characters"
            ValidEntry="False"
        end if
        if (ValidClickerID(theclickerid)="False") then
            ValidEntry="False"
            response.write "<p><H2>Error! Invalid Clicker ID </H2>"
            response.write "Clicker ID should be 8 characters  0-9, A-F"
        end if
'---------------------------------------------------------------
'  Make sure nothing funny like a ' in the fields
'----------------------------------------------------------------
        if (instr(theclickerid & thestudentid & thelastname & thefirstname,"'") >0 ) then
            validentry="False"
            response.write "<p><H2>Error! Fields must not include single quotes ' </H2>"
        end if
        if(ValidEntry) then            
            if (MyDataBase = "Access") then
                Status=AccessRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
            else 
                if (MyDataBase = "SQL")  then
                   Status=SQLRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
                else
                    Status = flatRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
                end if
            end if
            if(status = "OK") then
                WriteConfirmation thefirstname, thelastname, thestudentid, theclickerid
            else
                WriteForm thefirstname, thelastname, thestudentid, theclickerid
            End if
        Else    
            WriteForm thefirstname, thelastname, thestudentid, theclickerid
        End if
    End if 'New form or RegisterClickerID
End if  'Get LookupID or RegisterClickerID

'-----------------------------------------------------------------
' That's it..... Below are Functions and Subs
' The first couple might be customized for the registration and confirmation 
' messages.
'------------------------------------------------------------------

 Sub WriteForm (thefirstname, thelastname, thestudentid, theclickerid)
 '----------------------------------------------------------------------
 '  This outputs the form html data the student will see.
 '  If information is known about student, that can be prepopulated in form.
 '  May want to customize this for schools needs. Could use LDAP
 '  information to prepopulate student information
 '----------------------------------------------------------------------
  
response.write "<p><H2>Iclicker Registration Form</p></H2>   <p>&nbsp;</p>"

response.write "<form id=""form1"" name=""form1"" method=""post"" action=""" & LocalRegURL &  """>"
response.write "  <label>First Name"
  
response.write "  <input name=""First_Name"" type=""text"" id=""First_Name"" accesskey=""F"" tabindex=""1"" value=""" & thefirstname & """ />"
response.write "  </label> <p>"
response.write "    <label>Last Name"
response.write "    <input type=""text"" name=""Last_Name"" id=""Last_Name"" accesskey=""L"" tabindex=""2"" value=""" & thelastname & """ />"
response.write "    </label>"
response.write "  </p>"
response.write "  <p>"
response.write "    <label>Student_ID"
response.write "    <input type=""text"" name=""Student_ID"" id=""Student_ID"" accesskey=""I"" tabindex=""3"" value=""" & thestudentid & """/>"
response.write "    </label>"
response.write "  </p>"
response.write "  <p>"
response.write "    <label>Clicker_ID"
response.write "    <input type=""text"" name=""Clicker_ID"" id=""Clicker_ID"" accesskey=""c"" tabindex=""4"" value=""" & theclickerid & " ""/>"
response.write "    </label>"
response.write "  </p>"
response.write "  <p>"
response.write "    <label>"
response.write "   <input type=""submit"" name=""btnsubmit"" value=""Enter"" alt=""Enter"" title=""Enter"">"
response.write "    </label>"
response.write "  </p>"
response.write "</form>"
response.write "<p>&nbsp; </p>"
response.write "</body>"
response.write "</html>"
 End Sub
 
 
 Sub WriteConfirmation (thefirstname, thelastname, thestudentid, theclickerid)
 '---------------------------------------------------------------------------
 '  Write confirmation HTML 
 '----------------------------------------------------------------------------
 response.write "<H1> iclicker registration confirmation </H1> <br>"
 response.write "<table>"
 response.write "<tr><td> First name </td><td><b>"
 response.write thefirstname & "</td></b>"
 
 response.write "<tr><td> Family name </td><td><b>"
 response.write thelastname & "</td></b>"
 
 response.write "<tr><td> Student ID </td><td><b>"
 response.write thestudentid & "</td></b>"
 
 response.write "<tr><td> Clicker ID </td><td><b>"
 response.write theclickerid & "</td></b>"
 
 response.write "</table>"
 End Sub


Function FlatRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
'----------------------------------------------------------------------
'   Appends registration to a flat file
'----------------------------------------------------------------------
Const Appending=8
On Error resume Next

Dim OpenFileobj, FSOobj,FilePath
dim regstring

FilePath=Server.MapPath(RegFileName) ' located in the same directory
flatregisterclicker="Fail"
Set FSOobj = Server.CreateObject("Scripting.FileSystemObject")
if FSOobj.fileExists(FilePath) Then
    Set OpenFileobj = FSOobj.OpenTextFile(FilePath, Appending)
    regstring = "#" & theclickerid & " , " & thelastname & " , " & thefirstname & " , " & thestudentid & " , " & now
    OpenFileobj.WriteLine(regstring)
    OpenFileobj.Close
    Set OpenFileobj = Nothing
    If (Err.Number <> 0) then
        response.write "There was an error and we were not able to register the clicker. <p> If this continues please contact the Webmaster." '  & ErrNumber & ":" & errdescription 
        Error.Clear
    else
        flatregisterclicker="OK"
    End If
Else
    response.write("Error unable to open registration file. <p> If problem persists please contact Webmaster <p>")
    flatregisterclicker="Fail"
End if
Set FSOobj = Nothing
end function


Function SQLRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
'----------------------------------------------------------------------------------
'   Sends registration to sql server
'----------------------------------------------------------------------------------
On Error resume Next
Dim conn
dim sqlstring

set conn = Server.CreateObject("ADODB.Connection")
conn.Open "Driver={SQL Server};Server=(local);Database=PER;Trusted_Connection=yes;"
sqlstring = "insert into "&  SQLTableName & " (whenadded, firstname, lastname, studentid, clickerid) values ('" & now & "', '" & thefirstname & "', '"& thelastname & "', '" & thestudentid & "', '" & theclickerid & "')"
conn.execute sqlstring
conn.close
set conn = nothing
SQLRegisterClicker = "OK"
If (Err.Number <> 0) then
SQLRegisterClicker = HandleError(Err.Description, err.number)
Error.Clear
End If
end function

Function AccessRegisterClicker(thefirstname, thelastname, thestudentid, theclickerid)
'----------------------------------------------------------------------------------
'   Sends registration to access server
'----------------------------------------------------------------------------------
On Error resume Next
Dim conn
dim sqlstring
dim FilePath
dim cst

FilePath=Server.MapPath(AccessFileName)
cst = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FilePath

set conn = CreateObject("ADODB.Connection") 
conn.open cst

sqlstring = "insert into "&  SQLTableName & " (whenadded, firstname, lastname, studentid, clickerid) values ('" & now & "', '" & thefirstname & "', '"& thelastname & "', '" & thestudentid & "', '" & theclickerid & "')"
conn.execute sqlstring
conn.close
set conn = nothing
AccessRegisterClicker = "OK"

If (Err.Number <> 0) then
    AccessRegisterClicker = HandleAccessError(Err.Description, err.number)
    Error.Clear
End If
end function

Sub SQLLookupClickerid(clickerid)
'---------------------------------------------------------------------------------
'  This routine queries the database for registrations matching the
'  clickerID sent in the request and returns the response in a format
'  appropriate for igrader.  
'  Returned format (clickerID firstname lastname studentid date with carriage-return linefeed between records)
'  Original by Adam Feil  5-24-08
'  Tested and modified by Tim Stelzer 5-25-08  
'------------------------------------------------------------------------------------

dim conn
dim rs
dim sqlstr

set conn = Server.CreateObject("ADODB.Connection")
conn.Open "Driver={SQL Server};Server=(local);Database=PER;Trusted_Connection=yes;"
Set rs = Server.CreateObject("ADODB.Recordset")  ' create recordset object - this will hold the query result
sqlstr = "SELECT * from " & SQLTableName & " where clickerId = '" & clickerid & "' order by whenadded desc"
rs.open sqlstr, conn   ' open the recordset and fill by running the query sqlstr on the connection conn

do while not rs.eof   ' do while not end of file is true for the recordset
    response.write("1 " &vbtab & rs("clickerId")& vbtab & rs("firstname") & vbtab & rs("lastname") & vbtab & rs("studentId") & vbtab & rs("whenadded") &vbcrlf)
    rs.movenext
loop
'clean up... if you don't do this, the connection, which takes up server memory resources, will live on for some period of time
rs.close
conn.close
set conn = nothing
end sub


Sub AccessLookupClickerid(clickerid)
'---------------------------------------------------------------------------------
'  This routine queries the database for registrations matching the
'  clickerID sent in the request and returns the response in a format
'  appropriate for igrader.  
'  Returned format (clickerID firstname lastname studentid date with carriage-return linefeed between records)
'  Original by Adam Feil  5-24-08
'  Tested and modified by Tim Stelzer 5-25-08  
'------------------------------------------------------------------------------------

dim conn
dim rs
dim cst
dim sqlstr
dim FilePath

FilePath=Server.MapPath(AccessFileName)
cst = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FilePath
set conn = CreateObject("ADODB.Connection") 
conn.open cst


Set rs = Server.CreateObject("ADODB.Recordset")  ' create recordset object - this will hold the query result
sqlstr = "SELECT * from " & SQLTableName & " where clickerId = '" & clickerid & "' order by whenadded desc"
rs.open sqlstr, conn   ' open the recordset and fill by running the query sqlstr on the connection conn

do while not rs.eof   ' do while not end of file is true for the recordset
    response.write("1 " &vbtab & rs("clickerId")& vbtab & rs("firstname") & vbtab & rs("lastname") & vbtab & rs("studentId") & vbtab & rs("whenadded") &vbcrlf)
    rs.movenext
loop
'clean up... if you don't do this, the connection, which takes up server memory resources, will live on for some period of time
rs.close
conn.close
set conn = nothing
end sub

'--------------------------------------------------------------------------
' Below are functions to verify the clickerID is valid using the  checksum.
'----------------------------------------------------------------------------

Function ValidClickerID(ClickerID) 
dim myByte(4)
dim i
dim sum
sum = "0000"
if (len(clickerid) =8) then
    ValidClickerID = "True"
else
    ValidClickerID = "False"
end if
for i = 1 to 4
    mybyte(i) = hex2bin(mid(clickerid,2*i-1))
    mybyte(i) = mybyte(i) & hex2bin(mid(clickerid,2*i))
    if (instr(mybyte(i),"Error") >0 ) then
        ValidClickerID = "False"
    end if
    call AddBits(sum,mybyte(i))
next 
if (instr(sum,"1") > 0) then
    ValidClickerID = "False"
end if
End Function


Sub AddBits(sum,mybyte)
'------------------------------------------
'   Adds each of the bits to sum
'------------------------------------------
dim i
dim temp
temp = ""
for i = 1 to 8
    if (instr(mid(sum,i),mid(mybyte,i)) = 1) then
        temp = temp & "0"
    else
        temp = temp & "1"
    end if
next
sum = temp
end sub

Function Mid(thestring,i)
'------------------------------------------
'   Returns character i of thestring
'------------------------------------------ 
dim temp

    temp = left(thestring,i)
    mid = right(temp,1)

end function

Function Hex2Bin(hexval)
'------------------------------------------------------
'   Takes Hexvalue and returns string binary equivalent 
'   as a string of zeros and ones
'------------------------------------------------------- 
dim slook 
dim dec
dim bin(16)
slook = "0123456789ABCDEF"
bin(0) = "Error"
bin(1) = "0000"
bin(2) = "0001"
bin(3) = "0010"
bin(4) = "0011"
bin(5) = "0100"
bin(6) = "0101"
bin(7) = "0110"
bin(8) = "0111"
bin(9) = "1000"
bin(10) = "1001"
bin(11) = "1010"
bin(12) = "1011"
bin(13) = "1100"
bin(14) = "1101"
bin(15) = "1110"
bin(16) = "1111"
hex2bin = bin(instr(slook,hexval))    
end function


Function HandleError(ErrDescription, ErrNumber)
'----------------------------------------------
' Handles Error returned from SQL database 
'----------------------------------------------
if (errnumber = -2147217900) then
    response.write "This clicker has already been registered to you!"
    HandleError="OK"
else
    response.write "There was an error and we were not able to register the clicker. <p> If this continues please contact the web master." '  & ErrNumber & ":" & errdescription 
    HandleError="Fail"
end if
End function

Function HandleAccessError(ErrDescription, ErrNumber)
'----------------------------------------------
' Handles Error returned from SQL database 
'----------------------------------------------
if (errnumber = -2147467259) then
    response.write "This clicker has already been registered to you!"
    HandleError="OK"
else
    response.write "There was an error and we were not able to register the clicker. <p> If this continues please contact the web master." '  & ErrNumber & ":" & errdescription 
    HandleError="Fail"
end if
End function


 %>